#ifndef VS1053_H
#define VS1053_H

#include <Arduino.h>
#include <SPI.h>

#define TRUE  0
#define FALSE  1

//VS10xx SCI Registers
#define SCI_MODE 0x00
#define SCI_STATUS 0x01
#define SCI_BASS 0x02
#define SCI_CLOCKF 0x03
#define SCI_DECODE_TIME 0x04
#define SCI_AUDATA 0x05
#define SCI_WRAM 0x06
#define SCI_WRAMADDR 0x07
#define SCI_HDAT0 0x08
#define SCI_HDAT1 0x09
#define SCI_AIADDR 0x0A
#define SCI_VOL 0x0B
#define SCI_AICTRL0 0x0C
#define SCI_AICTRL1 0x0D
#define SCI_AICTRL2 0x0E
#define SCI_AICTRL3 0x0F

//MP3 Player Shield pin mapping. See the schematic
#define MP3_XDCS 2 //Data Chip Select  (analog 4 on the music shield) / BSYNC Pin  
#define MP3_XCS 3 //Control Chip Select   (analog 5 on the music shield) Pin (for accessing SPI Control/Status registers)

#define MP3_DREQ 4 //Data Request Pin: Player asks for more data
#define MP3_RESET 7 //Reset is active low

#define mp3BufferSize 32 

#define green_led 8 
#define red_led 9 



class VS1053Class  {
 private:
 void Mp3WriteRegister(unsigned char addressbyte, unsigned char highbyte, unsigned char lowbyte);
 unsigned int Mp3ReadRegister (unsigned char addressbyte);
 



 public:
 VS1053Class();
 ~VS1053Class();
 void init();
 boolean bufferFull();
 void playSilence(long ms);
 void playByte(uint8_t  byteToPlay);
 void playBuffer(uint8_t*  mp3DataBuffer);
 void Mp3SetVolume(unsigned char leftchannel, unsigned char rightchannel);
 void getMp3Tag(char  mp3TagBuffer[]);

 int need_data;
 char* mp3TagTitle;
 char* mp3TagArtist;

};


extern VS1053Class VS1053;
#endif
